//$Id: uves.dpr,v 1.12 2001/05/02 15:14:07 amodigli Exp $
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//COPYRIGHT (c) 1996 European Southern Observatory
//LICENSE
//
//PROJECT:   VLT Data Flow System
//AUTHOR:    S.Wolf - ESO/DMD/DPG
//SUBSYSTEM: Pipeline
//PURPOSE:   Definition of reduction rules for UT2/UVES
//
//$Name:  $
//$Revision: 1.12 $
//$Log: uves.dpr,v $
//Revision 1.12  2001/05/02 15:14:07  amodigli
//Added some cases to support FIBER mode
//
//Revision 1.11  2001/03/09 12:21:08  amodigli
//Takem out some commented commands
//
//Revision 1.10  2001/03/02 14:16:11  amodigli
//Now is case sensitive
//
//Revision 1.9  2001/01/04 11:09:40  amodigli
//Added Id, Name, Revision, Log conf. control info
//
//Revision 1.8  2000/04/03 13:08:02  oboitqui
//stability check added by Andreas KAUFER
//
//Revision 1.7  2000/03/31 16:22:30  oboitqui
//Paranal 2 release
//
//Revision 1.6  2000/03/06 18:01:36  ddorigo
//*** empty log message ***
//
//Revision 1.5  2000/03/06 17:23:44  ddorigo
//*** empty log message ***
//
//Revision 1.4  2000/03/03 14:49:24  oboitqui
//*** empty log message ***
//
//Revision 1.3  2000/03/03 12:15:08  oboitqui
//Release for Paronal including slicer and efficiency corrections.
//
//Revision 1.2  2000/02/16 14:23:00  oboitqui
//Corrected typo
//
//Revision 1.1  2000/02/16 14:05:12  oboitqui
//First release:
//files taken from quality/calibDB area
//
//Revision 1.21  1999/06/09 08:56:32  quality
//ntt update
//
//Revision 1.19  1999/05/14 12:56:13  quality
//ntt update
//
//Revision 1.18  1999/05/04 15:26:21  quality
//ntt update
//
//Revision 1.17  1999/03/29 13:31:19  quality
//ntt update
//
//Revision 1.11  1999/03/29 12:01:44  quality
//ntt update
//
//Revision 1.9  1999/03/26 17:21:57  quality
//ntt update
//
//Revision 1.3  1999/03/16 09:39:43  quality
//ntt update
//
//Revision 1.2  1999/03/10 17:38:40  quality
//ntt update
//
//Revision 1.1  1999/03/09 12:51:51  quality
//Initial revision
//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
instrument: "UVES";
name:       "$Id: uves.dpr,v 1.12 2001/05/02 15:14:07 amodigli Exp $";
version:    "$Revision: 1.12 $";



//
// Reduction rules for signal_newFrame
// ===================================
//

UVES_MASTER_BIAS_B(REF_IMAGE){
      execute uves_cal_mkmaster(REF_IMAGE);
}

UVES_MASTER_BIAS_R(REF_IMAGE){
      execute uves_cal_mkmaster(REF_IMAGE);
}

UVES_MASTER_DARK_B(REF_IMAGE){
  if (ref_bias=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_BLUE,
                         MIN_RET=1, MAX_RET=1))
      execute uves_cal_mkmaster(REF_IMAGE,ref_bias);
}


UVES_MASTER_DARK_R(REF_IMAGE){
  if (ref_bias_l=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias_u=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDU,
                         MIN_RET=1, MAX_RET=1))
      execute uves_cal_mkmaster(REF_IMAGE,ref_bias_l,ref_bias_u);
}


UVES_MASTER_FLAT_B(REF_IMAGE){
  if (ref_bias=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_BLUE,
                         MIN_RET=0, MAX_RET=1) &&
      ref_dark=gen_query(REF_IMAGE, DO_CATG=MASTER_DARK_BLUE,
                         MIN_RET=0, MAX_RET=1) &&
      ref_drs=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1))
      execute uves_cal_mkmaster(REF_IMAGE,ref_bias,ref_dark,ref_drs,ref_order,ref_back);
}


UVES_MASTER_FLAT_R(REF_IMAGE){
  if (ref_bias_l=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_dark_l=gen_query(REF_IMAGE, DO_CATG=MASTER_DARK_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_drs_l=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_l=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back_l=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias_u=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDU,
                         MIN_RET=0, MAX_RET=1) &&
      ref_dark_u=gen_query(REF_IMAGE, DO_CATG=MASTER_DARK_REDU,
                         MIN_RET=0, MAX_RET=1) &&
      ref_drs_u=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_u=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back_u=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1))
      execute uves_cal_mkmaster(REF_IMAGE,ref_bias_l,ref_dark_l,ref_drs_l,ref_order_l,ref_back_l,ref_bias_u,ref_dark_u,ref_drs_u,ref_order_u,ref_back_u);
}

UVES_CAL_PREDICT_R(REF_IMAGE){
  if (ref_line=gen_query(REF_IMAGE, DO_CATG=LINE_REFER_TABLE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_form_l=gen_query(REF_IMAGE, DO_CATG=MASTER_FORM_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_form_u=gen_query(REF_IMAGE, DO_CATG=MASTER_FORM_REDU,
                         MIN_RET=0, MAX_RET=1))
    execute uves_cal_predict(REF_IMAGE,ref_line,ref_form_l,ref_form_u);
}

UVES_CAL_PREDICT_B(REF_IMAGE){
  if (ref_line=gen_query(REF_IMAGE, DO_CATG=LINE_REFER_TABLE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_form=gen_query(REF_IMAGE, DO_CATG=MASTER_FORM_BLUE,
                         MIN_RET=0, MAX_RET=1))
    execute uves_cal_predict(REF_IMAGE,ref_line,ref_form);
}


UVES_CAL_ORDERPOS_B(REF_IMAGE){
  if (ref_drs=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_BLUE,
                         MIN_RET=0, MAX_RET=1))
	execute uves_cal_orderpos(REF_IMAGE,ref_drs);
}


UVES_CAL_ORDERPOS_R(REF_IMAGE){
  if (ref_drs_l=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_drs_u=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDU,
                         MIN_RET=0, MAX_RET=1))
	execute uves_cal_orderpos(REF_IMAGE,ref_drs_l,ref_drs_u);
}


UVES_CAL_WAVECAL_B(REF_IMAGE){
  if (ref_drs=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_line=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE,
                         MIN_RET=0, MAX_RET=1) &&
      ref_lref=gen_query(REF_IMAGE, DO_CATG=LINE_REFER_TABLE,
                         MIN_RET=1, MAX_RET=1))
	execute uves_cal_wavecal(REF_IMAGE,ref_drs,ref_order,ref_line,ref_lref);
}

UVES_CAL_WAVECAL_R(REF_IMAGE){
  if (ref_drs_l=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_l=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_line_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_drs_u=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_u=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_line_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU,
                         MIN_RET=0, MAX_RET=1) &&
      ref_lref=gen_query(REF_IMAGE, DO_CATG=LINE_REFER_TABLE,
                         MIN_RET=1, MAX_RET=1))
	execute uves_cal_wavecal(REF_IMAGE,ref_drs_l,ref_order_l,ref_line_l,ref_drs_u,ref_order_u,ref_line_u,ref_lref);
}


UVES_CAL_RESPONSE_B(REF_IMAGE){
  if (ref_drs=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_BLUE,
                         MIN_RET=0, MAX_RET=1) &&
      ref_flat=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_flux=gen_query(REF_IMAGE, DO_CATG=FLUX_STD_TABLE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_extc=gen_query(REF_IMAGE, DO_CATG=EXTCOEFF_TABLE,
                         MIN_RET=1, MAX_RET=1))
	execute uves_cal_response(REF_IMAGE,ref_drs,ref_order,ref_back,ref_lin1,ref_lin2,ref_lin3,ref_bias,ref_flat,ref_flux,ref_extc);
}

UVES_CAL_RESPONSE_R(REF_IMAGE){
  if (ref_drs_l=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_l=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back_l=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias_l=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_flat_l=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_drs_u=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_u=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back_u=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias_u=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDU,
                         MIN_RET=0, MAX_RET=1) &&
      ref_flat_u=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_flux=gen_query(REF_IMAGE, DO_CATG=FLUX_STD_TABLE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_extc=gen_query(REF_IMAGE, DO_CATG=EXTCOEFF_TABLE,
                         MIN_RET=1, MAX_RET=1))
	execute uves_cal_response(REF_IMAGE,ref_drs_l,ref_order_l,ref_back_l,ref_lin1_l,ref_lin2_l,ref_lin3_l,ref_bias_l,ref_flat_l,ref_drs_u,ref_order_u,ref_back_u,ref_lin1_u,ref_lin2_u,ref_lin3_u,ref_bias_u,ref_flat_u,ref_flux,ref_extc);
}


UVES_OBS_EXTRORD_B(REF_IMAGE){
  if (ref_drs=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_ord=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1))
      execute uves_obs_extrord(REF_IMAGE,ref_drs,ref_ord);
}

UVES_OBS_EXTRORD_R(REF_IMAGE){
  if (ref_drs_l=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_drs_u=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_ord_l=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_ord_u=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1))
      execute uves_obs_extrord(REF_IMAGE,ref_drs_l,ref_drs_u,ref_ord_l,ref_ord_u);
}

UVES_OBS_SCIRED_B(REF_IMAGE){
  if (ref_drs=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_BLUE,
                         MIN_RET=0, MAX_RET=1) &&
      ref_flat=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_resp=gen_query(REF_IMAGE, DO_CATG=INSTR_RESPONSE_BLUE,
                         MIN_RET=0, MAX_RET=1))
	execute uves_obs_scired(REF_IMAGE,ref_drs,ref_order,ref_back,ref_lin1,ref_lin2,ref_lin3,ref_bias,ref_flat,ref_resp);
}

UVES_OBS_SCIRED_R(REF_IMAGE){
  if (ref_drs_l=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_l=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back_l=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias_l=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_flat_l=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_resp_l=gen_query(REF_IMAGE, DO_CATG=INSTR_RESPONSE_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_drs_u=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_u=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back_u=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias_u=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDU,
                         MIN_RET=0, MAX_RET=1) &&
      ref_flat_u=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_resp_u=gen_query(REF_IMAGE, DO_CATG=INSTR_RESPONSE_REDU,
                         MIN_RET=0, MAX_RET=1))
	execute uves_obs_scired(REF_IMAGE,ref_drs_l,ref_order_l,ref_back_l,ref_lin1_l,ref_lin2_l,ref_lin3_l,ref_bias_l,ref_flat_l,ref_resp_l,ref_drs_u,ref_order_u,ref_back_u,ref_lin1_u,ref_lin2_u,ref_lin3_u,ref_bias_u,ref_flat_u,ref_resp_u);
}

UVES_CCDTEST(REF_IMAGE){
      execute uves_cal_ccdtest(REF_IMAGE);
}

//
// FIBER MODE
// ==========
//


FIBER_UVES_CAL_FIBORDPOS(REF_IMAGE){
	execute fiber_uves_cal_fibordpos(REF_IMAGE);
}


FIBER_UVES_CAL_PREDICT(REF_IMAGE){
	execute uves_cal_predict(REF_IMAGE);
}

FIBER_UVES_CAL_WAVECAL(REF_IMAGE){
	execute fiber_uves_cal_wavecal(REF_IMAGE);
}

FIBER_UVES_CAL_RESPONSE(REF_IMAGE){
	execute fiber_uves_cal_response(REF_IMAGE);
}

FIBER_UVES_OBS_SCIRED(REF_IMAGE){
	execute fiber_uves_obs_scired(REF_IMAGE);
}







//
// Reduction rules for signal_produceProduct
// =========================================
//

PROD_UVES_MASTER_BIAS_B(REF_IMAGE){
  if (bias_list=gen_query(REF_IMAGE, DO_CATG=BIAS_BLUE,
                         MIN_RET=1, MAX_RET=20)
      execute uves_cal_mkmaster(bias_list);
}

PROD_UVES_MASTER_BIAS_R(REF_IMAGE){
  if (bias_list=gen_query(REF_IMAGE, DO_CATG=BIAS_RED,
                         MIN_RET=1, MAX_RET=20)
      execute uves_cal_mkmaster(bias_list);
}

PROD_UVES_MASTER_DARK_B(REF_IMAGE){
  if (dark_list=gen_query(REF_IMAGE, DO_CATG=DARK_BLUE,
                         MIN_RET=1, MAX_RET=20) && 
      ref_bias=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_BLUE,
                         MIN_RET=0, MAX_RET=1))
      execute uves_cal_mkmaster(dark_list,ref_bias);
}

PROD_UVES_MASTER_DARK_R(REF_IMAGE){
  if (dark_list=gen_query(REF_IMAGE, DO_CATG=DARK_RED,
                         MIN_RET=0, MAX_RET=99) && 
      ref_bias_l=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_bias_u=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDU,
                         MIN_RET=0, MAX_RET=1))
      execute uves_cal_mkmaster(dark_list,ref_bias_l,ref_bias_u);
}

PROD_UVES_MASTER_FLAT_B(REF_IMAGE){
  if (flat_list=gen_query(REF_IMAGE, DO_CATG=FLAT_BLUE,
                         MIN_RET=1, MAX_RET=20) && 
      ref_dark=gen_query(REF_IMAGE, DO_CATG=MASTER_DARK_BLUE,
                         MIN_RET=0, MAX_RET=1) &&
      ref_bias=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_BLUE,
                         MIN_RET=0, MAX_RET=1) &&
      ref_drs=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1))
      execute uves_cal_mkmaster(flat_list,ref_dark,ref_bias,ref_drs,ref_order,ref_back);
}

PROD_UVES_MASTER_FLAT_R(REF_IMAGE){
  if (flat_list=gen_query(REF_IMAGE, DO_CATG=FLAT_RED,
                         MIN_RET=1, MAX_RET=20) && 
      ref_dark_l=gen_query(REF_IMAGE, DO_CATG=MASTER_DARK_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_dark_u=gen_query(REF_IMAGE, DO_CATG=MASTER_DARK_REDU,
                         MIN_RET=0, MAX_RET=1) &&
      ref_bias_l=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_bias_u=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDU,
                         MIN_RET=0, MAX_RET=1) &&
      ref_drs_l=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_drs_u=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_l=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_u=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back_l=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back_u=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1))
      execute uves_cal_mkmaster(flat_list,ref_dark_l,ref_dark_u,ref_bias_l,ref_bias_u,ref_drs_l,ref_drs_u,ref_order_l,ref_order_u,ref_back_l,ref_back_u);
}

PROD_UVES_CAL_PREDICT_B(REF_IMAGE){
  if (flat_list=gen_query(REF_IMAGE, DO_CATG=ARC_LAMP_FORM_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_line=gen_query(REF_IMAGE, DO_CATG=LINE_REFER_TABLE,
                         MIN_RET=1, MAX_RET=1))
      execute uves_cal_predict(flat_list,ref_line);
}

PROD_UVES_CAL_PREDICT_R(REF_IMAGE){
  if (flat_list=gen_query(REF_IMAGE, DO_CATG=ARC_LAMP_FORM_RED,
                         MIN_RET=1, MAX_RET=1) &&
      ref_line=gen_query(REF_IMAGE, DO_CATG=LINE_REFER_TABLE,
                         MIN_RET=1, MAX_RET=1))
      execute uves_cal_predict(flat_list,ref_line);
}

PROD_UVES_CAL_ORDERPOS_B(REF_IMAGE){
  if (flat_list=gen_query(REF_IMAGE, DO_CATG=ORDER_FLAT_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_drs=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_BLUE,
                         MIN_RET=0, MAX_RET=1))
      execute uves_cal_orderpos(flat_list,ref_drs);
}

PROD_UVES_CAL_ORDERPOS_R(REF_IMAGE){
  if (flat_list=gen_query(REF_IMAGE, DO_CATG=ORDER_FLAT_RED,
                         MIN_RET=1, MAX_RET=1) &&
      ref_drs_l=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_drs_u=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDU,
                         MIN_RET=0, MAX_RET=1))
      execute uves_cal_orderpos(flat_list,ref_drs_l,ref_drs_u);
}

PROD_UVES_CAL_WAVECAL_B(REF_IMAGE){
  if (lamp_list=gen_query(REF_IMAGE, DO_CATG=ARC_LAMP_BLUE,
                         MIN_RET=1, MAX_RET=1) && 
      ref_drs=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_line=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lref=gen_query(REF_IMAGE, DO_CATG=LINE_REFER_BLUE,
                         MIN_RET=1, MAX_RET=1))
      execute uves_cal_mkmaster(lamp_list,ref_drs,ref_order,ref_line,ref_lref);
}

PROD_UVES_CAL_WAVECAL_R(REF_IMAGE){
  if (lamp_list=gen_query(REF_IMAGE, DO_CATG=ARC_LAMP_RED,
                         MIN_RET=1, MAX_RET=1) && 
      ref_drs_l=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_drs_u=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_l=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_u=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_line_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_line_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lref=gen_query(REF_IMAGE, DO_CATG=LINE_REFER_BLUE,
                         MIN_RET=1, MAX_RET=1))
      execute uves_cal_mkmaster(lamp_list,ref_drs_l,ref_drs_u,ref_order_l,ref_order_u,ref_line_l,ref_line_u,ref_lref);
}

PROD_UVES_CAL_RESPONSE_B(REF_IMAGE){
  if (sci_list=gen_query(REF_IMAGE, DO_CATG=STANDARD_BLUE,
                         MIN_RET=1, MAX_RET=1) && 
      ref_drs=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_BLUE,
                         MIN_RET=0, MAX_RET=1) &&
      ref_flat=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_flux=gen_query(REF_IMAGE, DO_CATG=FLUX_STD_TABLE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_extc=gen_query(REF_IMAGE, DO_CATG=EXTCOEFF_TABLE,
                         MIN_RET=1, MAX_RET=1))
      execute uves_cal_response(sci_list,ref_drs,ref_order,ref_back,ref_lin1,ref_lin2,ref_lin3,ref_bias,ref_flat,ref_flux,ref_extc);
}

PROD_UVES_CAL_RESPONSE_R(REF_IMAGE){
  if (sci_list=gen_query(REF_IMAGE, DO_CATG=STANDARD_RED,
                         MIN_RET=1, MAX_RET=1) && 
      ref_drs_l=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_drs_u=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_l=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_u=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias_l=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_bias_u=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDU,
                         MIN_RET=0, MAX_RET=1) &&
      ref_flat_l=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_flat_u=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_flux=gen_query(REF_IMAGE, DO_CATG=FLUX_STD_TABLE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_extc=gen_query(REF_IMAGE, DO_CATG=EXTCOEFF_TABLE,
                         MIN_RET=1, MAX_RET=1))
      execute uves_cal_response(sci_list,ref_drs_l,ref_drs_u,ref_order_l,ref_order_u,ref_lin1_l,ref_lin2_l,ref_lin3_l,ref_lin1_u,ref_lin2_u,ref_lin3_u,ref_bias_l,ref_bias_u,ref_flat_l,ref_flat_u,ref_flux,ref_extc);
}


PROD_UVES_OBS_EXTRORD_B(REF_IMAGE){
  if (sci_list=gen_query(REF_IMAGE, DO_CATG=SCIENCE_BLUE,
                         MIN_RET=1, MAX_RET=20) &&
      ref_drs=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_ord=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1))
      execute uves_obs_extrord(sci_list,ref_drs,ref_ord);
}

PROD_UVES_OBS_EXTRORD_R(REF_IMAGE){
  if (sci_list=gen_query(REF_IMAGE, DO_CATG=ORDER_FLAT_RED,
                         MIN_RET=1, MAX_RET=20) &&
      ref_drs_l=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_drs_u=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_ord_l=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_ord_u=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1))
      execute uves_obs_extrord(sci_list,ref_drs_l,ref_drs_u,ref_ord_l,ref_ord_u);
}

PROD_UVES_OBS_SCIRED_B(REF_IMAGE){
  if (sci_list=gen_query(REF_IMAGE, DO_CATG=SCIENCE_BLUE,
                         MIN_RET=1, MAX_RET=1) && 
      ref_drs=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_BLUE,
                         MIN_RET=0, MAX_RET=1) &&
      ref_flat=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_resp=gen_query(REF_IMAGE, DO_CATG=INSTR_RESPONSE_BLUE,
                         MIN_RET=0, MAX_RET=1))
      execute uves_obs_scired(sci_list,ref_drs,ref_order,ref_back,ref_lin1,ref_lin2,ref_lin3,ref_bias,ref_flat,ref_resp);
}

PROD_UVES_OBS_SCIRED_R(REF_IMAGE){
  if (sci_list=gen_query(REF_IMAGE, DO_CATG=SCIENCE_RED,
                         MIN_RET=1, MAX_RET=1) && 
      ref_drs_l=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_drs_u=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_l=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_u=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias_l=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_bias_u=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDU,
                         MIN_RET=0, MAX_RET=1) &&
      ref_flat_l=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_flat_u=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_resp_l=gen_query(REF_IMAGE, DO_CATG=INSTR_RESPONSE_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_resp_u=gen_query(REF_IMAGE, DO_CATG=INSTR_RESPONSE_REDU,
                         MIN_RET=0, MAX_RET=1))
      execute uves_obs_scired(sci_list,ref_drs_l,ref_drs_u,ref_order_l,ref_order_u,ref_lin1_l,ref_lin2_l,ref_lin3_l,ref_lin1_u,ref_lin2_u,ref_lin3_u,ref_bias_l,ref_bias_u,ref_flat_l,ref_flat_u,ref_resp_l,ref_resp_u);
}

PROD_UVES_CCDTEST_B(REF_IMAGE){
  if (scr_list=gen_query(REF_IMAGE, DO_CATG=SCREEN_FLAT_BLUE,
                         MIN_RET=10, MAX_RET=20) &&
      bia_list=gen_query(REF_IMAGE, DO_CATG=BIAS_BLUE,
                         MIN_RET=5, MAX_RET=10))
      execute uves_cal_ccdtest(scr_list,bia_list);
}

PROD_UVES_CCDTEST_R(REF_IMAGE){
  if (scr_list=gen_query(REF_IMAGE, DO_CATG=SCREEN_FLAT_RED,
                         MIN_RET=10, MAX_RET=20) &&
      bia_list=gen_query(REF_IMAGE, DO_CATG=BIAS_RED,
                         MIN_RET=5, MAX_RET=10))
      execute uves_cal_ccdtest(scr_list,bia_list);
}

// Image slicer

UVES_OBS_SLICER_SCIRED_B(REF_IMAGE){
  if (ref_drs=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_BLUE3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_BLUE,
                         MIN_RET=0, MAX_RET=1) &&
      ref_flat=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_BLUE,
                         MIN_RET=1, MAX_RET=1) &&
      ref_resp=gen_query(REF_IMAGE, DO_CATG=INSTR_RESPONSE_BLUE,
                         MIN_RET=0, MAX_RET=1))
	execute uves_obs_slicer_scired(REF_IMAGE,ref_drs,ref_order,ref_back,ref_lin1,ref_lin2,ref_lin3,ref_bias,ref_flat,ref_resp);
}

UVES_OBS_SLICER_SCIRED_R(REF_IMAGE){
  if (ref_drs_l=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_l=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back_l=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3_l=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDL3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias_l=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_flat_l=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_REDL,
                         MIN_RET=1, MAX_RET=1) &&
      ref_resp_l=gen_query(REF_IMAGE, DO_CATG=INSTR_RESPONSE_REDL,
                         MIN_RET=0, MAX_RET=1) &&
      ref_drs_u=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_order_u=gen_query(REF_IMAGE, DO_CATG=ORDER_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_back_u=gen_query(REF_IMAGE, DO_CATG=BACKGR_TABLE_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin1_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU1,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin2_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU2,
                         MIN_RET=1, MAX_RET=1) &&
      ref_lin3_u=gen_query(REF_IMAGE, DO_CATG=LINE_TABLE_REDU3,
                         MIN_RET=1, MAX_RET=1) &&
      ref_bias_u=gen_query(REF_IMAGE, DO_CATG=MASTER_BIAS_REDU,
                         MIN_RET=0, MAX_RET=1) &&
      ref_flat_u=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_REDU,
                         MIN_RET=1, MAX_RET=1) &&
      ref_resp_u=gen_query(REF_IMAGE, DO_CATG=INSTR_RESPONSE_REDU,
                         MIN_RET=0, MAX_RET=1))
	execute uves_obs_slicer_scired(REF_IMAGE,ref_drs_l,ref_order_l,ref_back_l,ref_lin1_l,ref_lin2_l,ref_lin3_l,ref_bias_l,ref_flat_l,ref_resp_l,ref_drs_u,ref_order_u,ref_back_u,ref_lin1_u,ref_lin2_u,ref_lin3_u,ref_bias_u,ref_flat_u,ref_resp_u);
}
