/* ===========================================================================
 * $Id: rebin.h,v 1.2 2001/01/04 13:12:39 amodigli Exp $
 * $Name:  $
 * $Revision: 1.2 $
 * $Log: rebin.h,v $
 * Revision 1.2  2001/01/04 13:12:39  amodigli
 * Added Id, Name, Revision, Log conf. control info
 *
 * ===========================================================================
 */
/* 
 *
 *.COPYRIGHT   (C) 1999 European Southern Observatory
 *
 *.IDENT       rebin.h
 *
 *.KEYWORDS    Header file for module rebin.
 *
 *.ENVIRON     MIDAS 98NOV, FORS pipeline
 *
 *.LANGUAGE    ANSI C/KR C
 *
 *.AUTHOR      R. Palsa, ESO-DMO
 *
 *.VERSION     0.1 1999/02/28: Creation, RP
 *
 *----------------------------------------------------------------------------
 */

#include <stdio.h>
#include <math.h>
#include <midas_def.h>


#define PIXFRAC 0x0
#define LINPOL  0x1

#define MIN(A,B) ((A)  < (B) ? (A) : (B))
#define MAX(A,B) ((A)  > (B) ? (A) : (B))



typedef struct binned_data {
  int nbin;
  double *bval;
  double *bwidth;
  double *data;
} BinData;


#ifdef __STDC__
typedef int (*Method)(double *, double *, double *, int, double *, double *,
		      double *, int);
#else
typedef int (*Method)();
#endif



#ifdef __STDC__
int rebin(BinData *, BinData *, Method);
#else
int rebin();
#endif


#ifdef __STDC__
int rebpix(double *, double *, double *, int, double *, double *,
		      double *, int);
#else
int rebpix();
#endif


#ifdef __STDC__
int reblin(double *, double *, double *, int, double *, double *,
		      double *, int);
#else
int reblin();
#endif
