/* ===========================================================================
 * $Id: example_2.c,v 1.3 2001/01/04 13:23:03 amodigli Exp $
 * $Name:  $
 * $Revision: 1.3 $
 * $Log: example_2.c,v $
 * Revision 1.3  2001/01/04 13:23:03  amodigli
 * Added Id, Name, Revision, Log conf. control info
 *
 * ===========================================================================
 */
#include <math.h>
#include <physmod.h>
int messlevel = 3;
/************************************************************************* */
int main(){
/************************************************************************* */

   double x,y, x1, y1, l, dl, ls, le, fsr_min, fsr_max;
   int    m, m_min, m_max;
   double lmin,lmax, xpix, ypix,dxpix, dypix;
   int    mmin,mmax, ixpix, iypix;
   double lcent,xr,yr;

   printf ("******* Now Finding lambda,m (Blue 346) **************\n");

   airConfig(741.5/1.33322, 11.7, 3.0);
   cfgindx = uvesConfig('b','e',1,346.,1.0,1.0);

   printf("Air pressure = %f mmHg, Temperature = %f C,\nHumidity = %f mmHg\n", 741.5/1.33322, 11.7, 3.0 );
   printf("Air Index = %f\n",airIndex(346.));

   ccdSize(&ixpix,&iypix);

/* Compute the free spectral range */

   printf ("Determine the Free Spectral Range\n");
 
   dxpix = (double) ixpix;
   dypix = (double) iypix;

   m_min = -1;
   m_max = -1;

   lmModel(&lmax,&m_min,1.0,dypix);
   lmModel(&lmin,&m_max,dxpix,1.0); 

   lmModel(&lmax,&m_min,dxpix,dypix);
   lmModel(&lmin,&m_max,1.0,1.0); 
   
   printf("m_min= %d,m_max= %d\n",m_min,m_max); 

   
/* Computes the spectral format */

  printf("m, waveCentcol,   Start,     End,       yCent,    FSRmin,    FSRmax,  bin (mA)\n");
  for (m=m_max; m>=m_min; m--) {
     findFSR(m,&l, &fsr_min, &fsr_max);
     xyModel(l,m,&x,&y);
     dl = waveBin(l,m)*1e4; /* in mA */
     mmin  = m;
     mmax = m;

/* WARNING! The central column doesn't correspond to the central wavelength position */     
     lmModel(&lcent,&m,dxpix/2,y);
     xyModel(lcent,m,&xr,&yr);
     
     lmModel(&lmax,&mmax,dxpix,y);
     lmModel(&lmin,&mmin,1.0,y); 

     /* if (y>=0. && y <=ypix) */
     printf("%d %f %f %f %f %f %f %f\n",m,lcent,lmin,lmax,yr,fsr_min,fsr_max,dl);
  }


}
