! $Id: uves_annot.prg,v 1.2 2001/01/04 10:39:42 amodigli Exp $
!+++ UVES_ANNOT +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         uves_annot.prg
!
!.KEYWORDS      utility, POSTSCRIPT, label
!
!.USAGE         @p (IDENT) input annot font style
!
!.INPUT         input	(P1): input file (POSTSCRIPT)
!               annot	(P2): annotation string or name of annotation file
!				The annotation string has in any case to be
!				set in quotes (").
!               font	(P3): font to be used for annotations:
!				c: Courier, t: Times, h: Helvetica
!		style	(P4): text style parameters:
!				x,y,angle,size,skip,red,green,blue
!				x:	x position [cm]
!				y:	y position [cm]
!				angle:	rotation angle [degrees]
!				size:	font size [pt]
!				skip:	baselineskip factor (skip*size)
!				red,green,blue are the fractions of the
!					text colour.
!
!				origin is at the lower left corner.
!
!.OUTPUT        
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT	P3	c
!		P4	0,0,0,14,1,0,0,0
!
!.PURPOSE       Put annotations on the plot (POSTSCRIPT).
!
!.ALGORITHM     Set the global keys which are read by uves_annot.exe.
!
!.ENVIRON       
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       1.0 1999/07/22  Created.
!		    1999/07/23	Write the defaults to INPUTR.
!
!.COMMENT	Input file will be changed!
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.2 $
! $Log: uves_annot.prg,v $
! Revision 1.2  2001/01/04 10:39:42  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------
crossref input annot font style

define/param p1 ? c "Enter name of input file  (POSTSCRIPT):"
define/param p2 ? c "Enter annotation string or name of annotation file:"
define/param p3 c c "Enter text font (c,t,h: Courier,Times,Helvetica):"
define/param p4 0,0,0,14,1,0,0,0 c "Enter text style parameter:"


OUT_A = p1				!postscript file
OUT_B = "/tmp/{p1}"			!temporary output file

if m$exist(p2) .eq. 1 then		!annotation file passed
  IN_A = "+"
  IN_B = p2
else					!annotation string passed
  IN_A = {p2}
  IN_B = "+"
endif

INPUTC = p3				!text font
write/key INPUTR 0,0,0,14,1,0,0,0	!set the defaults of text style
write/key INPUTR {p4}			!text style:
					!x,y,rotation angle,font size,
					!baseline skip,R,G,B

run PIPE_EXE:uves_annot
-rename {out_b} {out_a}
