! $Id: uves_expfit.prg,v 1.2 2001/01/04 10:39:51 amodigli Exp $
!+++ UVES_EXPFIT ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT	(C) 1998  European Southern Observatory
!
!.IDENT		uves_expfit.prg
!
!.KEYWORDS	Perform a exponential non-linear least squares fit
!
!.USAGE		@p (IDENT) image partbl accur
!
!.INPUT		image	(P1): name of data image
!		accur	(P3): accuracy of fit
!
!.OUTPUT	partbl	(P2): name of data table
!
!		data table created (having the same name as the imag but with
!		extension: .tbl); contains: input data, fit and residuals
!		updated parameter table
!
!.RETURN	Q1:  0: successful return
!		    <0: a successful return failed
!
!.DEFAULT
!
!.PURPOSE	Performs an exponential fit to the data in an onedimendional
!		image.
!
!.ALGORITHM	Calls expfini and nonlfit.
!		expfini: determines a first guess of the parameters used
!		nonlfit: performs the non-linear leasts squares fit
!			 [A*exp(-B*x) + C]
!
!.ENVIRON	UVES, CCDRED context
!   
!.LANGUAGE	MIDAS 98NOV
!
!.AUTHOR	Sebastian Wolf, ESO-DMO
!
!.VERSION	0.9 1998/02/04	Creation
!
!.COMMENT
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.2 $
! $Log: uves_expfit.prg,v $
! Revision 1.2  2001/01/04 10:39:51  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------
!
! Check parameters
!
define/param p1 ? c "Enter name of data image: "
define/param p2 ? c "Enter name of data table (will be created): "
define/param p3 ? c "Enter name of parameter table (full name): "
define/param p4 ? n "Enter accuracy of fit (chi^2 difference):"


@p uves_expfini {P1} {P2} {P3}
if {P4} .lt. 0.0 return -4
@p uves_nonlfit {P2} {P3} {P4}

return {Q1}
