! $Id: uves_extrref.prg,v 1.3 2001/09/03 13:32:05 amodigli Exp $
!+++ UVES_extrref +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         uves_extrref.prg
!
!.KEYWORDS      
!
!.USAGE         @p (IDENT) incat
!
!.INPUT         incat 	(P1): catalog of raw and reference frames
!
!.OUTPUT        
!
!.RETURN        Q1: =0: successful return
!                   -1: a successful return failed
!
!.DEFAULT	
!
!.PURPOSE       Extract the reference frames from a input catalog
!
!.ALGORITHM     Check each frame of the input catalog on the existence of
!		the porduct category ({h_procatg}), those frames are per
!		definitionem NO raw data.
!
!.ENVIRON       UVES context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       1.0 1999/12/17  Created.
!
!.COMMENT
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.3 $
! $Log: uves_extrref.prg,v $
! Revision 1.3  2001/09/03 13:32:05  amodigli
! Typo fixed (was missing a goto)
!
! Revision 1.2  2001/01/04 10:39:50  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------
define/param p1 ? c "Enter input catalog to extract reference data:"

define/local pid/c/1/15 extrref

define/local ifrm/c/1/100 " " ALL
define/local class/c/1/100 " " ALL
define/local catal/i/1/1 0
define/local i1/i/1/1 0

show/icat {p1} >Null
if outputi(1) .lt. 1 goto ERR1

mess/out 3 {pid} "Extracting reference frames from {p1} ..."

create/icat data.cat NULL {UVES_IDSTRNG} >Null
create/icat refer.cat NULL {h_procatg} >Null

iloop:
  store/frame ifrm {p1} 1 ELOOP
  if m$existd(ifrm,h_procatg) .gt. 0 then
    add/icat refer.cat {ifrm} >Null
    goto iloop
  endif
  subtract/icat {p1} {ifrm} >Null
  add/icat data.cat {ifrm} >Null
  goto iloop
eloop:

mess/out 3 {pid} "Reference data extracted. Saved: refer.cat"
!read/icat data.cat
!read/icat refer.cat
return 0

ERR1:
  mess/out 1 {pid} "Empty input catalog `{p1}`"
  return -1
