! $Id $
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 1998  European Southern Observatory (ESO)
!
!.IDENT       uves_get_pversion.prg
!
!.KEYWORDS    Pipeline initialization
!
!.USAGE       @p(IDENT)
!
!.INPUT       none
!
!.OUTPUT      p_version
!
!.RETURNS     The recipe returns p_version on success. 
!
!.PURPOSE     The procedure get pipe version ID
!
!.ENVIRON     UVES context
!
!.LANGUAGE    MIDAS command language 98NOV.
!
!.AUTHOR      A. Modigliani, ESO-DMO
!
!.VERSION     0.5  2001/05/21:  Creation
!
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.3 $
! $Log: uves_get_pversion.prg,v $
! Revision 1.3  2001/08/12 16:14:05  amodigli
! corrected id in case of development
!
! Revision 1.2  2001/08/01 15:57:46  amodigli
! Added prefix uves/ in pipe version id
!
! Revision 1.1  2001/05/23 15:29:15  amodigli
! Added uves_get_pversion.prg to get on the
! fly the UVES pipeline version number from
! file $PIPE_HOME/uves
!
!
!------------------------------------------------------------------------------

! Procedure identification
define/local procID/c/1/80	"GetPipeVersion"

! Get Pipeline version ID
! Unlock keyword if necessary

  define/local lockno/i/1/1    0
  info/keyw p_version
  lockno = mid$info(4)
  if lockno .ne. 0 then
    unlock/key p_version {lockno}
  endif
  if m$exist(p_version_file) .eq. 1 then
    write/_out {p_version_file} | write/key p_version
    inputi = m$index(p_version,"=")+1
    p_version = "uves/{p_version({inputi}:)}"
  else        
    p_version = "development"
  endif
    
  if lockno .ne. 0 then
    lock/key p_version {lockno}
  endif

! Greeting
  mess/out 3 {procID} "Welcome, {user}"
  mess/out 3 {procID} "to UVES Pipeline version: {p_version}"
  write/out

! Copy version ID to global key
info/key pipeline_vers
if mid$info(1) .ne. 0 .and. mid$info(2) .eq. 4 then
  pipeline_vers(4) = "{p_version}"
endif
return {p_version}

