! $Id: uves_mod.prg,v 1.2 2001/01/04 10:39:42 amodigli Exp $
!+++ UVES_MOD ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT	(C) 1998  European Southern Observatory
!
!.IDENT		uves_mod.prg
!
!.KEYWORDS	Get the modulo of two values
!
!.USAGE		@p (IDENT) a b switch
!
!.INPUT		a	(P1): first value
!		b	(P2): second value
!		switch  (P3): 1: silent, 0 info on terminal
!
!.OUTPUT	[info on terminal]
!
!.RETURN	Q1:   a modulo b
!		Q2:   a / b		(real division)
!		Q3:   a div b		(integer division)
!
!.DEFAULT
!
!.PURPOSE	Get the modulo of two values
!
!.ALGORITHM	Divide a by b and return the rest in multiples of b.
!		Furthermore, the real and integer division will be returned.
!
!.ENVIRON	
!   
!.LANGUAGE	MIDAS 98NOV
!
!.AUTHOR	Sebastian Wolf, ESO-DMO
!
!.VERSION	0.5 1997/11/07	Creation
!		1.0 1999/04/15	Bug fixed: 0 MOD b == 0 !
!
!.COMMENT	Info on terminal only on high message levels (VERB/OUT VERY)
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.2 $
! $Log: uves_mod.prg,v $
! Revision 1.2  2001/01/04 10:39:42  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------
!
! Check parameters
!
define/parameter p1 ? n "a mod b; enter a: "
define/parameter p2 ? n "a mod b; enter b: "
define/parameter p3 0 n "1: silent, 0: info on terminal"

if {p1} .eq. 0 return 0 0 0

define/local i/i/1/1 0
define/local d/r/1/1 0
define/local n/r/1/1 0


d = {p1}*1.0/{p2}
i = m$nint(d-0.5)
n = {p1} - m$nint(d-0.5)*{p2}

if {p3} .eq. 0 mess/out 4 uves_mod "a MOD b={n} | a/b={d} | a DIV b={i}"

return {n} {d} {i}
