! $Id: uves_niceclear.prg,v 1.2 2001/01/04 10:39:40 amodigli Exp $
!+++ UVES_NICECLEAR +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT	(C) 1998  European Southern Observatory
!
!.IDENT		uves_niceclear.prg
!
!.KEYWORDS	Clear display and/or graphics windows
!
!.USAGE		@p (IDENT) sof_in out sof_ref [optpar]
!
!.INPUT		mode	(P1): selects 'devices' to be cleared
!				D: all image displays
!				G: all graphic displays
!
!.OUTPUT	
!
!.RETURN	Q1:  0: successful return
!		    -1: a successful return failed (keywords missing)
!		     1: graphics output disabled by pipeline
!
!.DEFAULT
!
!.PURPOSE	Clears all active devices. Image or graphic displays may be
!		selected, defaulted to both. At the end the default ITT will
!		be set to RAMP.
!
!.ALGORITHM	Checks existence of NICE-keywords: NICE_CREA, NICE_DIDS and
!		NICE_GIDS. Then loop through the ID-arrays which indicate the
!		existence of the graphics-windows and perform a CLEAR/DISP or
!		CLEAR/GRAPH.
!
!.ENVIRON	UVES context
!   
!.LANGUAGE	MIDAS 98NOV
!
!.AUTHOR	Sebastian Wolf, ESO-DMO
!
!.VERSION	1.0 1999/01/07	Creation.
!		1.2 1999/02/05	load/itt ramp included.
!
!.COMMENT
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.2 $
! $Log: uves_niceclear.prg,v $
! Revision 1.2  2001/01/04 10:39:40  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------


define/param p1 A c "Enter D: image-display, G: graphic-display, A: all "

define/local i1/i/1/1 0
define/local mode/c/1/1 {P1}

if m$existk("nice_crea") .eq. 0 return -1
if nice_crea .ne. "y" return 1			!graphics output disabled


set/format I1

branch mode A,D,G ALL,DIS,GRA

ALL:
DIS:
  if m$existk("nice_dids") .eq. 0 return -1

  do i1 = 1 9
    if nice_dids({i1}) .eq. 1 then
      assign/display d,{i1} >Null
      clear/display
    endif
  enddo
  if nice_dids(10) .eq. 1 then
    assign/display d,0 >Null
    clear/display
  endif
  if mode .eq. "A" goto GRA
  goto fini

GRA:
  if m$existk("nice_gids") .eq. 0 return -1

  do i1 = 1 9
    if nice_gids({i1}) .eq. 1 then
      assign/graphic g,{i1} >Null
      clear/graphic
    endif
  enddo
  if nice_gids(10) .eq. 1 then
    assign/graphic g,0 >Null
    clear/graphic
  endif

fini:
  load/itt ramp
  set/format
  return 0
