! $Id: uves_plt_ident.prg,v 1.5 2001/01/04 10:39:35 amodigli Exp $
!+++ UVES_PLT_IDENT +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         uves_plt_ident.prg
!
!.KEYWORDS      spectroscopy, echelle, display
!
!.USAGE         @p (IDENT) xoff yoff [xsize] [blabel] [csize]
!
!.INPUT         xoff    (P1): lower left x-offset of diagram X axis in mm
!               yoff    (P2): lower left y-offset of diagram Y axis in mm
!               xsize   (P3): x-size of digram
!               blabel  (P4): bottom right label
!               csize   (P5): character size
!
!.OUTPUT        
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!		OUT_A:  date and user (lower left label)
!		INPUTC: user name
!
!.DEFAULT	P3	+
!		P4	+
!		P5	0.2
!
!.PURPOSE       Put a user-date label at the left bottom of the plot.
!		You may add a further userdefined label at the right
!		bottom of the plot which has to be specified by p4 and p4.
!
!.ALGORITHM     Makes simple use of label/graph after retrieving the date via
!		m$time() and the user name via m$symbol().
!
!.ENVIRON       UVES, CCDRED context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       1.0 1999/10/07  Created.
!
!.COMMENT	This procedure should be used at the end of each plot in order
!		to get information of the date of creation.
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.5 $
! $Log: uves_plt_ident.prg,v $
! Revision 1.5  2001/01/04 10:39:35  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------

crossref xoff yoff xsize blabel csize

define/param p1 ? n "Enter lower left X offset of diagram [mm]: "
define/param p2 ? n "Enter lower left Y offset of diagram [mm]: "
define/param p3 + n "Enter X size of diagram: "
define/param p4 + c "Enter bottom right label: "
define/param p5 0.2 n "Enter character size: "

inputc = m$symbol("USER")
out_a = m$time()

if mid$sess(16:25) .eq. "99NOVpl1.1" then

    outputr(2) = {p2} * 0.9
    label/grap "{out_a}; USER: {inputc}" -{p1},-{outputr(2)},mm 0 {p5} 1

    if p3(1:1) .ne. "+" .AND. p4(1:1) .ne. "+" -
      label/grap {p4} {p3},-{outputr(2)},mm 0 {p5} 2
else

    label/grap "{out_a}; USER: {inputc}" {p1},{p2},no 0 {p5} 1

    if p3(1:1) .ne. "+" .AND. p4(1:1) .ne. "+" -
    label/grap {p4} {p3},{p2},no 0 {p5} 2

endif

return 0
