! $Id: uves_plt_set_size.prg,v 1.2 2001/05/30 16:31:15 amodigli Exp $
!+++ UVES_PLT_SET_SIZE +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         uves_plt_set_size.prg
!
!.KEYWORDS      keywords
!
!.USAGE         @p (IDENT)
!
!.INPUT         none
!.OUTPUT        out       
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT
!
!.PURPOSE       To set graph window sizes
!
!.ALGORITHM     SET the GRAPH window sizes
!
!.ENVIRON       UVES context
!   
!.LANGUAGE      MIDAS 01FEB
!
!.AUTHOR        Andrea Modigliani, ESO-DMO
!
!.VERSION       0.5 2001/05/02  Created.
!
!.COMMENT
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.2 $
! $Log: uves_plt_set_size.prg,v $
! Revision 1.2  2001/05/30 16:31:15  amodigli
! clean/doc
!
! Revision 1.1  2001/05/02 13:52:41  amodigli
! Created
!
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
! Who    When        Why               Where
! AM     30/05/01    clean/doc         all routine
!------------------------------------------------------------------------------
!Short description:
! very simple indeed..requires uves standard display setup (CONFIG/DISPLAY)
!------------------------------------------------------------------------------
!=============================================================
!Sizing the screen in mm units (99NOV pl1.1)
!=============================================================
define/local XSIZE/r/1/1 210			!total size [mm]
define/local YSIZE/r/1/1 160
define/local PXMM/r/1/1 3.5	     		!pixel per mm

show/disp >Null					        !Design the plot
if outputi(12) .lt. 0 then
  mess/out 1 plt_uves "NO plot device open!"
  return -1
endif

XSIZE = UVES_GXSZ({outputi(12)})		!Get the X-dim in pixel
YSIZE = UVES_GYSZ({outputi(12)})		!.. Y-dim in pixel
XLL = XLL * XSIZE / 625.
YLL = YLL * YSIZE / 425.			!coordinates in mm
if XLL .lt. 30 XLL = 30
if XLL .gt. 50 XLL = 50
if YLL .lt. 12 YLL = 12
if YLL .gt. 30 YLL = 30
XSZ = m$nint(XSIZE / PXMM - 0.5) - XLL		!X-size and Y-size of
YSZ = m$nint(YSIZE / PXMM - 0.5) - YLL * 1.5	!the plot in mm

return 0
!=================================================================


