! $Id: uves_proheadfinish.prg,v 1.4 2001/08/06 15:15:39 amodigli Exp $   
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 1998  European Southern Observatory (ESO)
!
!.IDENT       $RCSfile: uves_proheadfinish.prg,v $
!
!.KEYWORDS    Product header finalization
!
!.USAGE       finish/prohead result_cat lmode
!
!.INPUT       result_cat  (P1)   Name of result catalog
!             lmode       (P2)   2: Longlog is not finalized, if procedure is 
!                                   called within a super recipe.
!                                1: Longlog is always finalized.
!
!.OUTPUT      none.
!
!.RETURNS     The procedure returns 0 on success or 1 on error. Keyword Q1 is
!             updated with the exit status.
!
!.PURPOSE     The procedure closes the temporary file containing the
!             standard product header created by init/prohead and
!             copies the product header to all files contained in 
!             'result_cat'
!
!.ENVIRON     UVES context
!
!.LANGUAGE    MIDAS command language 98NOV.
!
!.AUTHOR      A.Modigliani (adapted from code of S. Bogun), ESO-DMO
!
!.VERSION     0.5  2001/04/23:  Creation
!
!------------------------------------------------------------------------------

define/param p1 ?  c    "Enter name of product catalog:"
define/param p2 ?  n    "Enter lmode:"


! Procedure identification
define/local procid/c/1/80  "ProHeadFinish"


! Local variables
define/local result_cat/c/1/64  {p1}
define/local lmode/i/1/1        {p2}
define/local separ/c/1/72       "-"           all


! return if lmode=2 and procedure invoked within a superrecipe
if lmode .eq. 2 .and. pipeline(6) .eq. 1 then
  return 0
endif

 
! Standard keys
define/local h_end_date/c/1/80   "eso.pro.{reci}.stop"
inputc = m$isodate()//"            "               ! get date in ISO 8601 format
define/local v_end_date/c/1/80   "{inputc(1:30)}"
define/local i_end_date/c/1/80   "Date when recipe execution finished"


prohead/out 1 {h_end_date} {v_end_date} "{i_end_date}" 3


! Close temporary file and write to all files in 'result_cat'
prohead/out 0 {result_cat}


return 0
