! $Id: uves_tst.prg,v 1.2 2001/01/04 10:39:57 amodigli Exp $
! $Name:  $
! $Revision: 1.2 $
! $Log: uves_tst.prg,v $
! Revision 1.2  2001/01/04 10:39:57  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------

define/param p1 200. n "Enter signal to noise:"
define/param p2 0.05 n "Enter signal to noise amplitude:"
define/param p3 0.1  n "Enter sky level:"
define/param p4 200. n "Enter width of obj spectrum in X (sigma of gaussian):"
define/param p5 1.0  n "Enter scale of object:"

DELETE/COMM EXTRAC/OPTI 
CREATE/COMM EXTRAC/optimal @p necopt
!CREATE/COMM EXTRAC/optimal @s necopt
!
! constants
!
define/local PI/r/1/1 3.1415927
define/local nx/i/1/1 200
define/local ny/i/1/1 45
define/local GAUSS/i/1/1 0

define/local nx2/r/1/1 0.0
define/local ny2/r/1/1 0.0
define/local sig/r/1/1 2.0
define/local sky/r/1/1 0.1
define/local ampl/r/1/1 0.05
define/local sn/r/1/1 200.
define/local ymin/r/1/1 0.0
define/local ymax/r/1/1 0.0
define/local yoff/r/1/1 1.5

sn   = {p1}
ampl = {p2}
sky  = {p3}

nx2 = {nx}/2.0
ny2 = {ny}/2.0
!
!
! Compute the OBJECT
!
create/image obj.bdf 2,{nx},{ny} 1,1,1,1 GAUSS {nx2},{p4},{ny2},{sig}
!create/image obj.bdf 2,{nx},{ny} 1,1,1,1 POLY 2.0
!create/image obj.bdf 2,{nx},{ny} 1,1,1,1 POLY 2.,-0.005
@a func2d sinim.bdf 2,{nx},{ny} 1,1,1,1 sin(x*2*{PI})*sin(x*2*{PI})
!
wr/out "Simulate background subtraction: create BACKGROUND descriptor"
write/desc obj BACKGROUND/c/1/11 SUBTRACTED
write/desc obj o_time/r/1/7 0.0 ALL
write/desc obj o_time/r/7/1 1.0
write/desc obj ident " " ALL
obj.bdf,ident = "OBJECT"
load/ima obj sca=1,10 cut=f,ihap

compute/ima obj = obj * ( sinim + 1.0 )
statistic/image obj ? ? ? SN
outputr(3) = m$sqrt({PI}) / (2*{sig})
compute/image obj = obj / {outputr(2)} / {outputr(3)} * {p5}

create/image flat.bdf 2,{nx},{ny} 1,1,1,1 GAUSS {nx2},200.,{ny2},50.
!
!
! Compute the FLATFIELD
!
statistic/imag flat ? ? ? SN
compute/imag flat = flat / {outputr(3)}
!
!
! Compute the NOISE
!
create/rand noise = obj.bdf FIBONACCI
compute/image noise = noise  * {ampl} + 1.0/{sn}
statistic/image noise
ymin = -{outputr(1)}
!
!
! Compute the final RAW image
!
compute/image raw = ( obj + {sky} ) * flat + noise
statistic/image raw
!
!
! Display components and resulting raw image
!
create/grap 0
set/graph default
ymax = {outputr(2)} + yoff
set/graph yaxis={ymin},{ymax}
plot/colu obj {nx2}
overplot/line 2 {plrgrap(1)},{sky} {plrgrap(2)},{sky}
overplot/colu noise {nx2} ? ? 2
overplot/colu flat {nx2} ? ? 2
overplot/colu raw {nx2} ? {yoff} 3
overplot/line 1 {plrgrap(1)},{yoff} {plrgrap(2)},{yoff}
copy/gra postscript
-rename postscript.ps uves_tst1.ps
!
!
! Create the order table
!
create/table order.tbl 5 1 NULL
create/column order.tbl :ORDER ? E15.5 R*4
create/column order.tbl :X ? F7.1 R*4
create/column order.tbl :Y ? F7.1 R*4
create/column order.tbl :YFIT ? G14.7 R*4
create/column order.tbl :RESIDUAL ? E12.6 R*4

order.tbl,:ORDER,1 = 1.0
order.tbl,:X,1 = 1.0
order.tbl,:Y,1 = nint({ny} / 2.0)	!23.0
order.tbl,:YFIT,1 = {ny} / 2.0
order.tbl,:RESIDUAL,1 = 0.5
!
! We have to remove these commands in order to be able to skip them
! within define/hough (crashes in regress/echelle) as the orders may not
! be found properly !???
! At the end do the regression by hand:
!
delete/comm regress/echelle
create/comm regress/echelle  write/out 
delete/comm load/echelle
create/comm load/echelle write/out 
delete/comm prepare/back
create/comm prepare/back write/out 
!
DEFINE/HOUG obj p4=DENSE p6=1,1
compute/table {ordtab} :Y = {ny2}
REGRE/POLY  {ORDTAB} :Y :X,:ORDER {DEFPOL(1)},{DEFPOL(2)}  KEYLONG  {SESSOUTV}
SAVE/REGR   {ORDTAB} COEFF  KEYLONG
COMPUTE/REGR   {ORDTAB} :YFIT     = COEFF
COMPUTE/TABLE    {ORDTAB} :RESIDUAL = :Y - :YFIT
!
!
! Reset the original commands
!
delete/comm regress/echelle
create/comm regress/echelle @s necregr
delete/comm load/echelle
create/comm load/echelle @s necload
delete/comm prepare/back
create/comm prepare/back @s necbackprep
!
!
! Show the result: order positions
!
load/echelle

@p uves_tst,REDUC

!..............................................................................
ENTRY REDUC
define/param p1 raw.bdf  i "Enter name of file to be reduced:"
define/param p2 flat.bdf i "Enter name of flatfield:"

define/local pid/c/1/20 REDUC
define/local exptime/r/1/1 1.0

set/echelle flat={p2}
set/echelle slit=15 skywind=-22,-7,7,22 offset=0
!set/echelle slit=16 skywind=-22,-8,8,22 offset=0
set/echelle rebopt=NO respopt=NO mgopt=NO
set/echelle extmtd=OPTIMAL ordtab=order.tbl

outputi(1) = slit + 1
outputi(2) = outputi(1) + slit - 1
average/row avg = obj {outputi(1)},{outputi(2)}

  mess/out 3 {pid} "Do the optimal extraction (slit: {slit}) ..."
  reduce/echelle {p1} r_{p1} !{SESSOUTV}
!
! The weights have to be rebinned, either.
!
!  rebin/echelle wbin.bdf r_wbin.bdf {SAMPLE} NONL {LINTAB} {SESSOUTV}
  -rename wbin.bdf r_wbin.bdf
!
! Now we got the optimal extracted object as well as the weights used for
! the optimal extraction process.
! Next we have to extract the lower and upper sky-windows in simple AVERAGE
! mode. Rebin these extracted sky-windows in the same way as the object.
! Due to fringes, in the red wavelength range we have to flatfield each sky
! window, separately before averaging and rebinning the extracted sky-windows.
! Finally, subtract the rebinned, flatfielded and weighted sky from the
! rebinned, flatfielded and weighted object.
!
! take a simple averaged flatfield
!  mess/out 3 {pid} "Extract averaged flatfield in the obj.window ..."
!  set/echelle extmtd=AVERAGE
!  extract/echelle {p2} x_{p2}  {SESSOUTV}

! take a weighted averaged flatfield
  mess/out 3 {pid} "Extract weighted flatfield in the obj.window ..."
  extract/optimal {p2} x_{p2} {slit},{echord(4)},{echord(5)} p7=NO  !{SESSOUTV}
  mess/out 3 {pid} "Normalize flatfield of object window ...\n"
  statistic/imag x_{p2} ? ? ? SN
  compute/imag x_{p2} = x_{p2} / {outputr(3)}
  mess/out 3 {pid} "Flatfield and rebin the opt.extracted object ..."
  compute/ima rf_{p1} = r_{p1} / x_{p2} >Null
!  rebin/echelle rf_{p1} r_{p1}  {SAMPLE} NONL {LINTAB}  {SESSOUTV}
  -rename rf_{p1} r_{p1}

  mess/out 3 {pid} "Extract averaged flatfield in the sky-windows ..."
  extract/sky {p2} r_{p2} AVERAGE {SESSOUTV}	 !{LINTAB_1},{LINTAB_2}
  -rename middumma.bdf r1_{p2}
  -rename middummb.bdf r2_{p2}
  
  mess/out 3 {pid} "Normalize flatfields of sky-windows ...\n"
  statistic/imag r1_{p2} ? ? ? SN		!Normalize flatfield
  compute/imag r1_{p2} = r1_{p2} / {outputr(3)} >Null
  statistic/imag r2_{p2} ? ? ? SN
  compute/imag r2_{p2} = r2_{p2} / {outputr(3)} >Null


  mess/out 3 {pid} "Extract, flatfield and rebin the sky-windows ..."
  exptime = m$value({p1},O_TIME(7))
  set/echelle EXTMTD=AVERAGE
  extract/sky {p1} r_sky AVERAGE {SESSOUTV}	!{LINTAB_1},{LINTAB_2} 
  -rename middumma.bdf r1_sky.bdf
  -rename middummb.bdf r2_sky.bdf

  compute/imag r_sky = r1_sky/r1_{p2} >Null
!  rebin/echelle r_sky r1_sky  {SAMPLE} NONL {LINTAB_1}  {SESSOUTV}
  -rename r_sky.bdf r1_sky.bdf
  compute/imag r_sky = r2_sky/r2_{p2} >Null
!  rebin/echelle r_sky r2_sky  {SAMPLE} NONL {LINTAB_2}  {SESSOUTV}
  -rename r_sky.bdf r2_sky.bdf

  mess/out 3 {pid} "Apply the weights to the averaged sky ..."
  compute/imag r_sky = r_wbin * (r1_sky + r2_sky) / 2.0 >Null

!FLATFIELDING with SKY: begin
!  filter/median sky s_sky 200,0,0
!  statistic/imag s_sky ? ? ? SN
!  compute/ima s_sky = s_sky / {outputr(3)}
!
!  compute/ima r_{p1} = r_{p1} / s_sky	!"Flatfielding with sky"
!  rebin/echelle r_{p1} rb_{p1}  {SAMPLE} NONL {LINTAB}
!  -rename rb_{p1} r_{p1}
!  compute/ima sky = sky / s_sky		!"Flatfielding with sky"
!FLATFIELDING with SKY: end


  mess/out 3 {pid} "Do the sky-subtraction ..."
  compute/ima rs_{p1} = r_{p1} - r_sky/{exptime} >Null
  compute/imag rm_{p1} = r_{p1} - (r1_sky + r2_sky) / 2.0 >Null


compute/imag quo1 = rs_{p1} / avg - 1.0
compute/imag quo2 = rm_{p1} / avg - 1.0
compute/imag qqq = abs( quo1 )
statistic/imag qqq ? ? ? SN
outputr(1) = outputr(1) * 100
outputr(2) = outputr(2) * 100
outputr(3) = outputr(3) * 100
set/format F5.2
wr/o
wr/o "OUTPUT:"
wr/o "Take the weigthed sky for reduction:"
wr/o "Maximum deviation from real object: {outputr(2)} %"
wr/o "Minimum deviation from real object: {outputr(1)} %"
wr/o "Mean deviation from real object:    {outputr(3)} %"

compute/imag qqq = abs( quo2 )
statistic/imag qqq ? ? ? SN
outputr(1) = outputr(1) * 100
outputr(2) = outputr(2) * 100
outputr(3) = outputr(3) * 100
set/format F5.2
wr/o
wr/o "Take the simple averaged sky for reduction:"
wr/o "Maximum deviation from real object: {outputr(2)} %"
wr/o "Minimum deviation from real object: {outputr(1)} %"
wr/o "Mean deviation from real object:    {outputr(3)} %"
set/format

wr/o "Mean flatfielded sky:                    rm_sky.bdf"
wr/o "Mean flatfielded and weigted sky:        r_sky.bdf"
wr/o "Flatfielded object:                      r_{p1}"
wr/o "Flatfielded and sky subtracted object:   rs_{p1}"

statist/imag r_{p1} ? ? ? SN
if outputr(2) .lt. 1.1 outputr(2) = 2.0
create/grap 1 >Null
set/graph yaxis=0,{outputr(2)}
set/grap ltype=1
plot/row avg >Null
set/grap colour=2
overplot/row rs_{p1} >Null
overplot/row quo1 ? ? 1.0 3 >Null

set/grap colour=4
overplot/row rm_{p1} >Null
overplot/row quo2 ? ? 1.0 3 >Null
!set/grap colour=1
!overplot/row r_{p1} ? ? 0.2 2
set/grap colour=3
overplot/row r_wbin >Null
set/grap colour=1
overplot/line 1 {plrgrap(1)},1.0 {plrgrap(2)},1.0 >Null

copy/gra postscript
-rename postscript.ps uves_tst2.ps
