/* ===========================================================================
 * $Id: uves_nonlfit.c,v 1.2 2001/01/04 13:36:35 amodigli Exp $
 * $Name:  $
 * $Revision: 1.2 $
 * $Log: uves_nonlfit.c,v $
 * Revision 1.2  2001/01/04 13:36:35  amodigli
 * Added Id, Name, Revision, Log conf. control info
 *
 * ===========================================================================
 */
#include <string.h>
#include <stdio.h>
#include <tblsys.h>
#include <tblerr.h>
#include <tbldef.h>
#include <macrogen.h>
#include <atype.h>
#include <midas_def.h>
#include <math.h>
/* #include <sunmath.h> */
#include "nrutil.h"

#define TRUE 1
#define FALSE 0
#define BELL  0x7
#define MLEN  1024
#define NLEN  80
#define MXCOL 8
#define IMAX  300

int   Dtid;                             /* table id of data table */
int   Ptid;                             /* table id of parameter table */
int   Icol[MXCOL+1];                    /* columns indices */
int   Dcoff[6];                         /* columns offsets & number of data */
int   Pcoff[4];                         /* columns offsets & number of data */
int   Ndcol, Ndrow, Npcol, Nprow;       /* number of columns, rows in tables */
int   Mlev;
char  Mes[MLEN];
char  Datname[NLEN] = "fit.tbl";        /* filename of data table, */
char  Parname[NLEN] = "par.tbl";        /* filename of parameter table */
float  *Dat;
float  *Par;

char  Prgnam[]  = "nonlfit";
char  Version[] = "1999.10.22-SW";

/*
  Icol:   1       2       3       4       5       6       7      8
          :X      :Y      :SIG    :FIT    :RESID  :PARAM  :FIX   :RESULT
*/
void user01();
void fgauss_c();

main()
{
  int    i, len, num, uni, null, fid;
  int    mfit, *listp, *ivector();
  int    szf, err;
  int    *iptr;
  char   *cptr;
  float  *x, *y, *sig, *fit, *res;
  float  *param, *eparam, acc, alamda, chisq;

  err = 0;
  szf = sizeof(float);

  SCSPRO("nonlfit");

  sprintf(Mes,"PROGRAM: nonlfit -- %s",Version);
  SCTPUT(Mes);

  SCKGETC("IN_A",1,NLEN,&len,Datname);     /* data table */
  SCKGETC("IN_B",1,NLEN,&len,Parname);     /* parameter table */
  SCKRDR("INPUTR",1,1,&len,&acc,&uni,&null);
  SCKRDI("INPUTI",1,9,&len,Icol,&uni,&null);
  SCKRDI("MESS_LEVEL",1,1,&len,&Mlev,&uni,&null);
  fid = Icol[MXCOL];

  sprintf(Mes,"INPUT:");
  sprintf(&Mes[strlen(Mes)],"\n  Data table:        %s",Datname);
  sprintf(&Mes[strlen(Mes)],"\n  Parameter table:   %s",Parname);
  sprintf(&Mes[strlen(Mes)],"\n  Table-column number used:");
  sprintf(&Mes[strlen(Mes)],"\n    Abszissa (X):    %d (data)",Icol[0]);
  sprintf(&Mes[strlen(Mes)],"\n    Measurement (Y): %d (data)",Icol[1]);
  sprintf(&Mes[strlen(Mes)],"\n    Sigmas (SIG):    %d (data)",Icol[2]);
  sprintf(&Mes[strlen(Mes)],"\n    Parameters:      %d (parameter)",Icol[5]);
  sprintf(&Mes[strlen(Mes)],"\n    FIX              %d (parameter)",Icol[6]);
  sprintf(&Mes[strlen(Mes)],"\n    Fit function:    %d",fid);
  messout(Mlev,4,Prgnam,Mes);

  TCTOPN(Datname,F_IO_MODE,&Dtid);
  TCTOPN(Parname,F_IO_MODE,&Ptid);

  TCIGET(Dtid,&Ndcol,&Ndrow,&null,&null,&null);
  num = Ndcol*Ndrow - 1;
  Dat = vector(0,num);
  read_table(Dtid,Ndcol,Ndrow,Dat,Dcoff);
  /*  show_table(Dtid,Ndcol,Ndrow,Dat,Dcoff); */

  TCIGET(Ptid,&Npcol,&Nprow,&null,&null,&null);
  num = Npcol*Nprow - 1;
  Par = vector(0,num);
  eparam = vector(0,num);
  read_table(Ptid,Npcol,Nprow,Par,Pcoff);
  /*  show_table(Ptid,Npcol,Nprow,Par,Pcoff); */

  listp = ivector(1,Nprow);
  for (i=0;i<MXCOL;i++) Icol[i] = Icol[i] - 1;  /* as C counts from 0 */

  check_table(Ptid,Icol[6],Nprow,Par,Pcoff,&listp[1],&mfit);

  x     = &Dat[ Dcoff[Icol[0]] ] - 1;
  y     = &Dat[ Dcoff[Icol[1]] ] - 1;
  sig   = &Dat[ Dcoff[Icol[2]] ] - 1;
  fit   = &Dat[ Dcoff[Icol[3]] ] - 1;
  res   = &Dat[ Dcoff[Icol[4]] ] - 1;
  param = &Par[ Pcoff[Icol[5]] ] - 1; 

  show_param(param,listp,Nprow,mfit);
  switch(fid)
    {
    case 1:
      nonlfit(x,y,sig,Ndrow,param,Nprow,listp,mfit,user01,eparam-1,&chisq);
      if (err < 0) { err_fini(err,-1.0); return(err); }
      calculfit(x, y, fit, res, user01, param, Ndrow, Nprow);
      break;
    case 2:
      nonlfit(x,y,sig,Ndrow,param,Nprow,listp,mfit,fgauss_c,eparam-1,&chisq);
      if (err < 0) { err_fini(err,-1.0); return(err); }
      calculfit(x, y, fit, res, fgauss_c, param, Ndrow, Nprow);
      break;
    default:
      err_fini(err,-1.0);
      return(err);
    }

  copy_column(&param[1],&Par[ Pcoff[Icol[7]] ],Nprow);
  write_tablec(Ptid,Icol[7],Nprow,Par,Pcoff); /* save result parameters */
  write_tablec(Dtid,Icol[3],Ndrow,Dat,Dcoff); /* save fit */
  write_tablec(Dtid,Icol[4],Ndrow,Dat,Dcoff); /* save residuals */

  TCTCLO(Dtid);
  TCTCLO(Ptid);
  SCKWRR("OUTPUTR",&chisq,1,1,&uni);                  /* return chi^2 */
  SCKWRC("Q1",1,"0",1,1,&uni);                       /* return Q1=0, ok! */

  SCSEPI();

}


void user01(x, param, y, deriv)
float x, *y, *deriv, *param;
{
  float e;

  e = exp(-param[2]*x);
  *y = param[1] * e  +  param[3];
  /*  printf("p1=%f p2=%f p3=%f\n",param[1],param[2],param[3]);
  printf("x=%f e=%f y=%f\n",x,e,*y); */
  deriv[1] = e;
  deriv[2] = -param[1]*x * e;
  deriv[3] = 1.0;
}



/* Fit: GAUSS + const */
void fgauss_c(x,a,y,dyda)
float x,a[5],*y,dyda[5];
{
  float fac,ex,arg;

  *y=0.0;
  arg=(x-a[2])/a[3];
  ex=exp(-arg*arg);
  fac=a[1]*ex*2.0*arg;
  *y = a[1]*ex + a[4];
  dyda[1]=ex;
  dyda[2]=fac/a[3];
  dyda[3]=fac*arg/a[3];
  dyda[4]=1.0;
  /* printf("%f %f %f %f  %f %f\n",a[1],a[2],a[3],a[4],x,*y); */
}



void fgauss(x,a,y,dyda,na)
float x,a[],*y,dyda[];
int na;
{
  int i;
  float fac,ex,arg;

  *y=0.0;
  for (i=1;i<=na-1;i+=3)
    {
      arg=(x-a[i+1])/a[i+2];
      ex=exp(-arg*arg);
      fac=a[i]*ex*2.0*arg;
      *y += a[i]*ex;
      dyda[i]=ex;
      dyda[i+1]=fac/a[i+2];
      dyda[i+2]=fac*arg/a[i+2];
    }
}


int err_fini(err,chisq)
int   err;
float chisq;
{
  int uni;

  TCTCLO(Dtid);
  TCTCLO(Ptid);
  SCKWRR("OUTPUTR",&chisq,1,1,&uni);                  /* return chi^2 */
  SCKWRC("Q1",1,"1",1,1,&uni);                       /* return Q1=0, ok! */
  SCSEPI();
}

int nomemory(svar,num)
int   num;
char  *svar;
{
  int nbad, uni;

  nbad = 0;
  sprintf(Mes,"Cannot allocate memory for %s [%d Byte]!\n",svar,num);
  messout(Mlev,1,Prgnam,Mes);
  if (Dtid != -1) TCTCLO(Dtid);
  if (Ptid != -1) TCTCLO(Ptid);
  SCSEPI();
  exit(1);
}
