! $Id: uves_obs_extrord.prg,v 1.3 2001/05/04 14:11:34 amodigli Exp $
!+++ UVES_OBS_EXTRORD +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         uves_obs_extrord
!
!.KEYWORDS      spectroscopy, echelle, order
!
!.USAGE         @p (IDENT) sof_in out sof_ref
!
!.INPUT         sof_in  (P1): set of input frames (ascii list)
!               sof_ref (P3): set of reference frames (ascii list)
!				ORDER_TABLE_x, DRS_SETUP_x
!
!.OUTPUT        out     (P2): path + basename of output files:
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT
!
!.PURPOSE       X
!
!.ALGORITHM     X
!
!.ENVIRON       UVES, CCDRED context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       0.5 1999/03/16  Created.
!		    1999/09/26	Check return value of FINISH/PIPE
!		    1999/12/10	main product was not sent to FINISH/PIPELINE!
!
!.COMMENT
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.3 $
! $Log: uves_obs_extrord.prg,v $
! Revision 1.3  2001/05/04 14:11:34  amodigli
! Added RB info to FITS header
!
! Revision 1.2  2001/01/04 13:44:14  amodigli
! Added Id, Name, Revision, Log conf. control info
!
!------------------------------------------------------------------------------
define/local line/c/1/79 "-" ALL
write/out {line}
LOG/REC uves_obs_extrord IN
!
! Check parameters
!
define/param p1 ? c "Enter name of ASCII filelist with INPUT frames:"
define/param p2 ? c "Enter name of ASCII filelist with REFERENCE frames:"
define/param p3 ? c "Enter name of OUTPUT frame:"
!
! local constant declaration
!
define/local pid/c/1/16 obs_extrord
!
! local variable declaration
!
define/local num/i/1/1 0
define/local main_prod/c/1/25 " " all

mess/out 3 {pid} -
  "Recipe UVES_OBS_EXTRORD will extract\nthe echelle orders."

@p uves_paragraph 1

INITIALIZE/PIPELINE {P1} {P3} extrI.cat + + + reject.cat result.cat
if {Q1} .gt. 0 return {Q1}

PROHEAD/INIT {P1} {P3} 1,"uves_cal_extrord" 


@p uves_paragraph 2
clean/disp A					!clear displays and graph.win.
create/icat extrO NULL >Null			!create output catalog

split/uves extrI.cat				!transpose and flip frames
show/icat split.cat >Null			!and split for RED arm
num = outputi(1)				!number of input frames
if num .lt. 1 return -1				!split.cat hold ONLY RAW frames


@p uves_extrord split.cat extrO.cat extrI.cat	!Do the order extraction.
if {q1} .lt. 0 goto ABORT
main_prod = q2

shortlog/out 1 "Order extraction done."

prohead/finish  extrO.cat 1

@p uves_paragraph 3

FINISH/PIPELINE extrO.cat {P2} + {main_prod}
if {q1} .eq. 1 goto ABORT

LOG/REC uves_obs_extrord OUT
@p uves_paragraph 4
return 0


ABORT:
mess/out 1 {pid} "Error in uves_extrord occured !"
write/error 1,APP,NO "Error in uves_extrord occured !"

