! $Id: uvesshow.prg,v 1.4 2001/08/07 08:15:51 amodigli Exp $
!+++ UVESSHOW +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         uvesshow.prg
!
!.KEYWORDS      help, context internals
!
!.USAGE         @p (IDENT) 
!
!.INPUT         
!
!.OUTPUT        
!
!.RETURN        
!
!.DEFAULT
!
!.PURPOSE       Display informations about the UVES context
!
!.ALGORITHM     Uses standard session commands like SHOW/SESS.
!
!.ENVIRON       UVES context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       0.5 1999/06/08  Created.
!
!.COMMENT
!------------------------------------------------------------------------------
! $Name:  $
! $Revision: 1.4 $
! $Id: uvesshow.prg,v 1.4 2001/08/07 08:15:51 amodigli Exp $
!------------------------------------------------------------------------------
!
SET/FORMAT I1  F12.5  
!ECHO/OFF
SESSLINE = 0 ! Initialize the line counter
IF P8(1:1) .EQ. "H" GOTO HELP
!
IF P1(1:1) .EQ. "G" GOTO GENERAL
IF P1(1:1) .EQ. "O" SHOW/ECHELLE O
IF P1(1:1) .EQ. "B" SHOW/ECHELLE B
IF P1(1:1) .EQ. "C" SHOW/ECHELLE C
IF P1(1:1) .EQ. "E" SHOW/ECHELLE E
IF P1(1:1) .EQ. "W" SHOW/ECHELLE W
IF P1(1:1) .EQ. "R" SHOW/ECHELLE R
!
GENERAL:
!
SHOW/SESS  "******************  UVES Parameters  ********************"
SHOW/SESS  "      +----------------------------------------+"
SHOW/SESS  "      |     UVES - Pipeline Version {p_version} |"
SHOW/SESS  "      +----------------------------------------+"


SHOW/SESS  " "
SHOW/ECHE G
SHOW/SESS  "    Chattiness     :  MESS_LEVEL = {MESS_LEVEL} [1..4]"
SHOW/SESS  "    Hardcopies     :  NICE_HCOPY = {NICE_HCOPY}"
SHOW/SESS  "    DRS-table-use  :  FORCE_DRS  = {FORCE_DRS}"

IF P1(1:1) .NE. "?" GOTO RET
!
RET:
SET/FORMAT
RETURN

HELP:

SHOW/SESS  "            ****  UVES   Main   Help    Message  ****"
SHOW/SESS  " "
SHOW/SESS  " This is the list of high level commands useful for an echelle"
SHOW/SESS  " reduction of data from the VLT UT2 echelle spectrograph UVES."
SHOW/SESS  " Optional parameters are set in brackets []."
SHOW/SESS  " "
SHOW/SESS  " More help is available for each command with HELP <command>"
SHOW/SESS  "   "
SHOW/SESS  "  SAVE/UVES name"
SHOW/SESS  "  INIT/UVES [name]"
SHOW/SESS  "  "
SHOW/SESS  "  SHOW/UVES"
SHOW/SESS  "  HELP/UVES keyword"
SHOW/SESS  "  SET/UVES"
SHOW/SESS  "  VERBOSE/OUT"
SHOW/SESS  "  CONFIG/DISP"
SHOW/SESS  "  "
SHOW/SESS  "  SPLIT/UVES uvesdata ..."
SHOW/SESS  "  MASTER/UVES calibdata ..."
SHOW/SESS  "  ORDERPOS/UVES flatfield ..."
SHOW/SESS  "  WAVECAL/UVES  ThAr-lamp ..."
SHOW/SESS  "  REDUCE/UVES   science ..."
SHOW/SESS  "  "
SHOW/SESS  "*** This HELP command is under development ***"

SET/FORMAT
RETURN


